DECLARE FUNCTION computeCT& (nbyte&, bsh() AS INTEGER, sieve() AS INTEGER)
DECLARE SUB PrintPrimes (nbyte&, sieve() AS INTEGER, bsh() AS INTEGER)
DECLARE SUB compute (nbyte&, bsh() AS INTEGER, sieve() AS INTEGER)

nbyte& = 16 * 1024 ' 56 * 1024 ... pretece kvuli znaminkovosti

nint& = (nbyte& + 1) \ 2  ' velikost pole v int16
nbit& = 16 * nint&
DIM sieve(0 TO nint& - 1) AS INTEGER' integer = 16bit, &/long znamena 32bit


DIM bsh(0 TO 15) AS INTEGER
bit% = 1
FOR i% = 0 TO 13 STEP 1
	bsh(i%) = bit%
	bit% = bit% * 2
NEXT i%
bsh(14) = bit%
bsh(15) = -32768

' Testovani funkci '
'CALL compute(nbyte&, bsh(), sieve())
'CTcount& = computeCT&(nbyte&, bsh(), sieve())
'PRINT CTcount&

' zjisti presnost citace
quantum# = 1
FOR i% = 5 TO i = 0 STEP -1
	time0# = TIMER
	DO
		time1# = TIMER
	LOOP WHILE time0# = time1#
	IF quantum# > time1# - time0# THEN quantum# = time1# - time0#
NEXT
'PRINT 1000 * 1000 * quantum#' minimalni krok citace v us

PRINT "   ======== Sieve of Eratosthenes Benchmark v1.6 ========"
PRINT "Benchmarking in a "; nbyte& \ 1024; " KB block of memory"
PRINT "Timer resolution is "; quantum# * 1000 * 1000; " us"

' !! otevreni souboru, vypis kompilatoru, hlavicka

OPEN "OUTPUT.TXT" FOR OUTPUT AS #1
PRINT #1, "# Microsoft Quick Basic 4.5 implementation by Jiri Zima"
PRINT #1, "# Benchmarking on a "; nbyte& \ 1024; " KB block with timer resolution of "; quantum# * 1000 * 1000; " us."
PRINT #1, "#    size  slow_version [us] fast_version [us]  # of inner iterations"

l& = 30
DO UNTIL l& > nbyte&

	' only slow version is implemented (fast reports the same)
	slow! = 1E+20
	rep& = 0
	
	'zkouma kolikrat musi byt sieve zopakovan, nez bude mit graf presnost 256
	time0# = TIMER
	DO WHILE TIMER - time0# < 256 * quantum#
		CALL compute(l&, bsh(), sieve())
	rep& = rep& + 1
	LOOP
	'PRINT rep&

	time1# = TIMER
	FOR r& = rep& - 1 TO 0 STEP -1
		CALL compute(l&, bsh(), sieve())
	NEXT
	time2# = TIMER
	slow# = (time2# - time1#) / rep& * 1000 * 1000


	PRINT #1, USING "######### "; l&;
	PRINT #1, USING "#############.### "; slow#;
	PRINT #1, USING "#############.### "; slow#;
	PRINT #1, USING "#################"; computeCT&(l&, bsh(), sieve())

	progress! = l& * 100 / nbyte&
	PRINT "Progress: "; l&; " of "; nbyte&; " = ";
	PRINT USING "##.###"; progress!;
	PRINT "%, rep="; rep&
   
	nextStep& = 11 * l& \ 10
	IF nextStep& > l& + 1 THEN l& = nextStep& ELSE l& = l& + 1

	' ukonceni programu stiskem ESC
	IF INKEY$ = "" THEN l& = nbyte& + 1
LOOP

PRINT : PRINT "Finished.": PRINT
CLOSE #1

SUB compute (nbyte&, bsh() AS INTEGER, sieve() AS INTEGER)
	nint& = (nbyte& + 1) \ 2  ' velikost pole v int16
	nbit& = 16 * nint&

	
	FOR i& = 1 TO nint& - 1 STEP 1
		sieve(i&) = 5 + 5 * 16 + 5 * 256 + 5 * 16 * 256
	NEXT i&
	sieve(0) = 3 + 5 * 16 + 5 * 256 + 5 * 16 * 256
   
	k& = 3
	WHILE k& * k& < nbit&
		IF (sieve(k& \ 16) AND bsh(k& AND 15)) = 0 THEN
			FOR i& = 2 * k& TO nbit& - 1 STEP k&
				sieve(i& \ 16) = sieve(i& \ 16) OR bsh(i& AND 15)
			NEXT i&
		END IF
		k& = k& + 1
	WEND
	'CALL PrintPrimes(nbyte&, sieve(), bsh())
END SUB

FUNCTION computeCT& (nbyte&, bsh() AS INTEGER, sieve() AS INTEGER)
	nint& = (nbyte& + 1) \ 2  ' velikost pole v int16
	nbit& = 16 * nint&

	count& = 0  'meri pocet pruchodu vnitrnim cyklem

	FOR i& = 1 TO nint& - 1 STEP 1
		sieve(i&) = 5 + 5 * 16 + 5 * 256 + 5 * 16 * 256
	NEXT i&
	sieve(0) = 3 + 5 * 16 + 5 * 256 + 5 * 16 * 256
  
	k& = 3
	WHILE k& * k& < nbit&
		IF (sieve(k& \ 16) AND bsh(k& AND 15)) = 0 THEN
			FOR i& = 2 * k& TO nbit& - 1 STEP k&
				sieve(i& \ 16) = sieve(i& \ 16) OR bsh(i& AND 15)
				count& = count& + 1
			NEXT i&
		END IF
		k& = k& + 1
	WEND
	computeCT& = count& 'vystup funkce
   
	' pro kontrolu mozne vypsat nalezena cisla
	'CALL PrintPrimes(nbyte&, sieve(), bsh())
END FUNCTION

SUB PrintPrimes (nbyte&, sieve() AS INTEGER, bsh() AS INTEGER)
	nint& = (nbyte& + 1) \ 2
	nbit& = 16 * nint&

	FOR k& = 0 TO nbit& - 1
		'PRINT sieve(k& \ 16); "   "; bsh(k& AND 15); "  ";
		IF (sieve(k& \ 16) AND bsh(k& AND 15)) = 0 THEN
			PRINT k&; "   ";
		END IF
	NEXT k&
	PRINT
	PRINT
END SUB

