
  R%=4
  n%=1024*512
  
  DIM gcc_fast_sieve% 50*4
  DIM ct_sieve% 55*4
  DIM assembly_fast_sieve% 174*4
  DIM workspace% 4*((n%+3)/4)
  

  REM R0-R7     Values of built-in integers A% - H%
  REM R8        Pointer to basic's workspace (start address referred to as argp)
  REM R9        Pointer to a list of L-values of the parameters
  REM R10       Number of parameters
  REM R11       Pointer to basic's string accumulator
  REM R12       Pointer to current basic statement
  REM R13       Pointer to basic's stack
  REM R14       Return address for BASIC

  REM R0 A%  a[] ... pointer to the data
  REM R1 B%  n   ... the length of the data
  REM R2 C%  rep ... the number of repetitions

  FOR pass%=0 TO 2 STEP 2
  P%=gcc_fast_sieve%
  [OPT pass%
.REPLOOP
        CMP     R2, #0
        MOVEQ   R15, R14
        STMFD   R13!, {R0,R1,R2-R8,R11,R12,R14}

        MOV     R3, #0
        CMP     R3, R1
        MOV     R12, R0
        MOV     R4, R1, ASL #3
        ADD     R8, R12, R1
        MOV     R2, #85
        BGE     L2667
.L2664
        STRB    R2, [R12, R3]
        ADD     R3, R3, #1
        CMP     R3, R1
        BLT     L2664
.L2667
        MOV     R0, #3
        MOV     R1, #9
        CMP     R1, R4
        MOV     R3, #83
        STRB    R3, [R12, #0]
        LDMCSFD R13!, {R0,R1,R2-R8,R11,R12,R15}
.L2672
        AND     R2, R0, #7
        MOV     R14, R0, ASL #1
        ADD     R7, R1, #1
        LDRB    R3, [R12, R0, LSR #3]
        ADD     R6, R0, #1
        MOV     R3, R3, ASR R2
        TST     R3, #1
        BNE     L2671
        SUBS    R11, R14, R4
        BPL     L2671
        MOV     R5, #1
.L2677
        MOV     R3, R11, ASR #3
        AND     R1, R11, #7
        LDRB    R2, [R8, R3]
        ADDS    R11, R11, R0
        ORR     R2, R2, R5, ASL R1
        STRB    R2, [R8, R3]
        BMI     L2677
.L2671
        ADD     R1, R7, R14
        MOV     R0, R6
        CMP     R1, R4
        BCC     L2672
        LDMFD   R13!, {R0,R1,R2-R8,R11,R12,R14}
        SUB     R2, R2, #1
        B       REPLOOP        
  ]
  NEXT pass%
  PRINT "sizeof(gcc_fast_sieve)="; P%-gcc_fast_sieve%

  FOR pass%=0 TO 2 STEP 2
  P%=ct_sieve%
  [OPT pass%
        STMFD   R13!, {R2-R8,R9,R10,R11,R12,R14}
        MOV     R9,#0

        MOV     R3, #0
        CMP     R3, R1
        MOV     R12, R0
        MOV     R4, R1, ASL #3
        ADD     R8, R12, R1
        MOV     R2, #85
        BGE     L2667
.L2664
        STRB    R2, [R12, R3]
        ADD     R3, R3, #1
        CMP     R3, R1
        BLT     L2664
.L2667
        MOV     R0, #3
        MOV     R1, #9
        CMP     R1, R4
        MOV     R3, #83
        STRB    R3, [R12, #0]
        BCS     LQUIT
.L2672
        AND     R2, R0, #7
        MOV     R14, R0, ASL #1
        ADD     R7, R1, #1
        LDRB    R3, [R12, R0, LSR #3]
        ADD     R6, R0, #1
        MOV     R3, R3, ASR R2
        TST     R3, #1
        BNE     L2671
        SUBS    R11, R14, R4
        BPL     L2671
        MOV     R5, #1
.L2677
        MOV     R3, R11, ASR #3
        AND     R1, R11, #7
        LDRB    R2, [R8, R3]
        ADDS    R11, R11, R0
        ORR     R2, R2, R5, ASL R1
        STRB    R2, [R8, R3]
        ADD     R9, R9, #1
        BMI     L2677
.L2671
        ADD     R1, R7, R14
        MOV     R0, R6
        CMP     R1, R4
        BCC     L2672
.LQUIT
        MOV     R0, R9
        LDMFD   R13!, {R2-R8,R9,R10,R11,R12,R15}
  ]
  NEXT pass%
  PRINT "sizeof(ct_sieve)="; P%-ct_sieve%

  FOR pass%=0 TO 2 STEP 2
  P%=assembly_fast_sieve%
  [OPT pass%
.REPLOOP
        CMP     R2, #0
        MOVEQ   R15, R14
        STMFD   R13!, {R0,R1,R2-R8,R9,R10,R11,R12,R14}

        MOV     R10, R0
        CMP     R1, #0
        LDMLEFD R13!, {R0,R1,R2-R8,R9,R10,R11,R12,R15}

        ADD     R7, R0, R1
        SUB     R7, R7, #(4*7)
        MOV     R2, #&55
        ORR     R2, R2, R2, LSL #8
        ORR     R2, R2, R2, LSL #16
        MOV     R3, R2
        MOV     R4, R2
        MOV     R5, R2
        MOV     R6, R2
        MOV     R8, R2
        MOV     R12, R2
.FASTFILL
        STMIA   R10!, {R2,R3,R4,R5,R6,R8,R9,R10,R12}
        CMP     R10, R7
        BLE     FASTFILL
        ADD     R7, R7, #(4*7)
        CMP     R10, R7
        BGE     INITIALIZED
.SLOWFILL
        STRB    R2, [R10], #1
        CMP     R10, R7
        BLT     SLOWFILL
.INITIALIZED
        MOV     R5, #1
        MOV     R4, R1, ASL #3
        ADD     R8, R0, R1
        MOV     R1, #9
        CMP     R1, R4
        MOV     R2, #&53
        STRB    R2, [R0]
        LDMCSFD R13!, {R0,R1,R2-R8,R9,R10,R11,R12,R15}

        MOV     R10, #3
.LOOP
        AND     R2, R10, #7
        LDRB    R3, [R0, R10, LSR #3]
        ANDS    R3, R3, R5, ASL R2
        BNE     CONTINUE
        RSBS    R12, R4, R10, ASL #1
        BPL     CONTINUE
.INNER_LOOP
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BPL     CONTINUE
        AND     R7, R12, #7
        LDRB    R2, [R8, R12, ASR #3]
        ORR     R2, R2, R5, ASL R7
        STRB    R2, [R8, R12, ASR #3]
        ADDS    R12, R12, R10
        BMI     INNER_LOOP
.CONTINUE
        ADD     R1, R1, R10, ASL #1
        ADD     R1, R1, #1
        ADD     R10, R10, #1
        CMP     R1, R4
        BCC     LOOP

        LDMFD   R13!, {R0,R1,R2-R8,R9,R10,R11,R12,R14}
        SUB     R2, R2, #1
        B       REPLOOP        
  ]
  NEXT pass%
  PRINT "sizeof(assembly_fast_sieve)="; P%-assembly_fast_sieve%

  REM PROCtest2
  PROCmeasure
END

DEF PROCsieve(address%,length%,repetitions%)
  A%=address%
  B%=length%
  C%=repetitions%
  CALL gcc_fast_sieve%
ENDPROC

DEF PROCfast_sieve(address%,length%,repetitions%)
  A%=address%
  B%=length%
  C%=repetitions%
  CALL assembly_fast_sieve%
ENDPROC

DEF FNct_sieve(address%,length%)
  A%=address%
  B%=length%
  =USR(ct_sieve%)

DEF PROCmeasure
  LOCAL quantum%, i%, t0%, t1%, dt%, msg$, slow, fast, rep%, l%, old_l%, r%, dt_slow, dt_fast
  PRINT "=== Sieve of Eratosthenes Benchmark v1.8 (Assembly via BBC Basic variant) ==="
  PRINT "Benchmarking in a ";n%/1024;" KB block of memory"

  quantum%=1<<30
  FOR i%=0 TO 5
    t0%=TIME
    REPEAT
      t1%=TIME
    UNTIL t0%<>t1%
    dt%=t1%-t0%
    IF quantum%>dt% THEN
      quantum%=dt%
    ENDIF
  NEXT i%    
  PRINT "Timer resolution is ";10000*quantum%;" us"
  
  REM f%=OPENOUT "eratosth/txt"  
  f%=OPENOUT "RAM::RamDisc0.eratosth/txt"  
  BPUT#f%,"# Assembly implementation assembled by BBC BASIC V"
  BPUT#f%,"# slow_version is fast_sieve() C function as compiled by gcc-2.95.3, while"
  BPUT#f%,"# fast_version is hand tuned assembly"
  msg$="# Benchmarking on a "+STR$(n%/1024)+" KB block with timer resolution of "+STR$(10000*quantum%)+" us"
  BPUT#f%,msg$
  BPUT#f%,"#    size  slow_version [us] fast_version [us]  # of inner iterations"
                    
  l%=30
  WHILE l%<n%
    slow=1E20
    fast=1E20
    rep%=0
  
    FOR i%=1 TO R%
      t0%=TIME
      IF i%=1 THEN
        WHILE TIME-t0%<256*quantum%
          PROCsieve(workspace%,l%,1)
          rep%+=1
        ENDWHILE
      ELSE
        PROCsieve(workspace%,l%,rep%)
      ENDIF
      t1%=TIME
        PROCfast_sieve(workspace%,l%,rep%)
      t2%=TIME
      dt_slow=(t1%-t0%+0.0)/rep%
      dt_fast=(t2%-t1%+0.0)/rep%
      IF slow>dt_slow
        slow=dt_slow
      ENDIF
      IF fast>dt_fast
        fast=dt_fast
      ENDIF
    NEXT i%
    
    PRINT "Progress: ";l%;" of ";n%;" = "; (l%*100.0)/n%  ;"%, rep="; rep%
    msg$=STR$(l%)+" "+STR$(10000*slow)+" "+STR$(10000*fast)+" "+STR$(FNct_sieve(workspace%,l%))
    BPUT#f%,msg$
        
    old_l%=l%
    l%=(11*l%)/10
    IF l%<=old_l% THEN 
      l%=l%+1
    ENDIF
  ENDWHILE

  CLOSE#f%
END


DEF PROCprint_primes(f%,address%)
  LOCAL N% : LOCAL k% : LOCAL index% : LOCAL mask% : LOCAL ct%
  N%=8*n%
  ct%=1
  FOR k%=0 TO N%-1 
    index% = k%>>3
    mask% = (1<<(k% AND 7))
    IF ((address%?index%) AND mask%) = 0 THEN
      msg$=STR$(k%)
REM      +" "+STR$(ct%)
      BPUT#f%, msg$
      PRINT k%;" ";
      ct%+=1
    ENDIF
  NEXT k%
  PRINT
END

DEF PROCtest
  A%=workspace%
  B%=n%
  C%=1
  CALL assembly_fast_sieve%
REM  CALL gcc_fast_sieve%
REM  x%=USR(ct_sieve%)
  f%=OPENOUT "primes"
  PROCprint_primes(f%,workspace%)
  CLOSE#f%
END

DEF PROCtest2
  f%=OPENOUT "tst/txt"
  l%=30
  WHILE l%<n%
    msg$=STR$(l%)+"  "+STR$(FNct_sieve(workspace%,l%))
    BPUT#f%,msg$
    old_l%=l%
    l%=(11*l%)/10
    IF l%<=old_l% THEN 
      l%=l%+1
    ENDIF
  ENDWHILE
  CLOSE#f%
END
