	.386p

public	fast_sieve

S_DATA	segment dword public use32
S_DATA	ends
S_CODE	segment byte public use32
S_CODE	ends

	assume  cs:S_CODE, ds:S_DATA

S_CODE	segment

	align 32
	
fast_sieve	proc

	sub	esp, 28
	push	ebp
	push	edi
	push	esi
	push	ebx		; esp=orig_esp-28-4*4=orig_esp-44

	mov	ebx, [52+esp]	; n = [orig_esp+8]
	mov	ecx, ebx
	shr	ecx, 1
	lea	edx, [ebx*8]	; N = 8*n
	mov	[28+esp], edx	; [orig_esp-16] = N
	mov 	edi, [48+esp]	; edi = a
	mov	esi, edi
	add	esi, ebx	; esi = b = a+n

	mov	ebp, edi	; ebp = a
	mov	eax, 5555h
	cld
	rep	stosw	
	test	ebx, 1
	jz	n_even
	stosb
n_even:
	mov	byte ptr [ebp], 53h	; a[0]=0x53
	mov	edi, ebp	; edi = a
	mov	ebp, esi	; ebp = b

	mov	esi, 2		; esi = k = 2
	lea	eax, [esi+esi]
	mov	[16+esp], eax  ; kk=4

continue:
	lea	ecx, [1+esi+esi]	; ecx=1+2*k
	inc	esi			; k++
	mov	eax, [16+esp]		; kk+=ecx
	add	eax, ecx
	cmp	eax, [28+esp]
	jae	quit
	mov	[16+esp], eax

	mov	edx, esi
	mov	eax, 1
	mov	ecx, esi
	sar	edx, 3			; edx=k>>3
	and	ecx, 7			; al=1<<(k&7)
	sal	eax, cl
	test	byte ptr [edi+edx], al
	jnz	continue
	
	lea	ebx, [esi+esi]
	sub	ebx, [28+esp]		; ebx=i=2*k-N
	jns	continue
inner_loop:		
    ; INPUT ebx=i esi=k ebp=b
    ; USING eax=1<<(i&7) ebx=i ecx=i&7 edx=i>>3 esi=k ebp=b 
    ; FREE  edi
	mov	edx, ebx
	mov	eax, 1
	mov	ecx, ebx
	sar	edx, 3			; edx=i>>3
	and	ecx, 7
	sal	eax, cl
	or	byte ptr [ebp+edx], al
	add	ebx, esi		; ebx=i, esi=k
	jns	continue
	mov	edx, ebx
	mov	eax, 1
	mov	ecx, ebx
	sar	edx, 3			; edx=i>>3
	and	ecx, 7
	sal	eax, cl
	or	byte ptr [ebp+edx], al
	add	ebx, esi		; ebx=i, esi=k
	js	inner_loop
	jmp 	continue

quit:
	pop	ebx
	pop	esi
	pop	edi
	pop	ebp
	add	esp, 28
	ret

fast_sieve	endp

S_CODE		ends

	end


