
	.model	small, C
	.8086
	smart
	nojumps

public	fast_sieve

	codeseg

fast_sieve	proc

	pushf			; to preserve D-flag
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	sub	sp, 2*3
	mov	bp, sp

a	equ	bp+24
n	equ	bp+26
kk5lo	equ	bp+0
kk5hi	equ	bp+2
N5lo	equ	bp+4
N5hi	equ	n		; N=n<<3, N5=N<<5 so N5hi=n

	mov	BYTE ptr [N5lo], 0h
	mov	si, [a]		; SI = a
	mov	di, si		; DI = a
	mov	dx, [n]		; DX = n

	push	es
	mov	ax, ds
	mov	es, ax
	cld
	mov	cx, dx
	shr	cx, 1
	mov	ax, 5555h
	rep	stosw
	test	dl, 1
	jz	n_even
	stosb
n_even:
	pop	es
	mov	di, si			; SI=a
	add	di, dx			; DI=b=a+n
	mov	BYTE ptr [si], 53h	; a[0]=0x53

	mov	dx, cx			; k=2,  DX:CH = k<<5  (CX==0 here)
	mov	ch, 2*32
	mov	BYTE ptr [kk5lo], 4*32
	mov	WORD ptr [kk5hi], dx
	mov	bx, OFFSET bit_table

continue:		; BX=bit_table, SI=a[], DI=b[], DX:CH = k<<5, AX=tmp, CL=tmp2
	mov	bp, sp
	mov	cl, ch			; (kk<<5)=(kk<<5)+2*(DX:CH)+64
	or	cl, 16			;  kk    = kk    +2*k      +1
	shl	cl, 1
	mov	ax, WORD ptr [kk5hi]
	adc	ax, dx
	add	BYTE ptr [kk5lo], cl
	adc	ax, dx
	mov	WORD ptr [kk5hi], ax
	add	ch, 32			; (DX:CH)+=32
	adc	dx, 0			; k++
	cmp 	ax, [N5hi]
	jnb	quit

	mov	al, ch
	xlatb
	xchg	bx, dx
	test	BYTE ptr DS:[bx+si], al
	xchg	bx, dx
	jnz	continue

;        mov	ax, [N5hi]		;this seems to be a bug in tasm
;        mov	ax, WORD ptr [N5hi]
;        mov	ax, WORD [N5hi]		;as AX from this line differs from previous two

	mov	ax, dx			; i=(2*k-N)<<5 (BP:CL=(DX:CH<<1)-(N5hi:N5lo))
	mov	cl, ch
	shl	cl, 1			; 2
	rcl	ax, 1			; 2
	sub	cl, BYTE ptr [N5lo]
	sbb	ax, [N5hi]
	mov	bp, ax

; INPUT:  DI=b,  BP:CL = i<<5,   DX:CH = k<<5,   BX = bit_table
; USING:  AL
inner_loop:
	mov	al, cl			; 2		(1)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jc	continue		; 4

	mov	al, cl			; 2		(2)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jc	continue		; 4

	mov	al, cl			; 2		(3)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jc	continue		; 4

	mov	al, cl			; 2		(4)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jc	continue		; 4

	mov	al, cl			; 2		(5)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jc	continue		; 4

	mov	al, cl			; 2		(6)
	xlatb	; al=DS:[bx+al]		; 11
	or 	BYTE ptr DS:[bp+di], al	; 16+9
	add	cl, ch			; 3
	adc	bp, dx			; 3           ____44
	jnc	inner_loop		; 16
	jmp	continue

quit:
	add	sp, 2*3
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	ret


fast_sieve endp

;              8086 times for effective address (EA) calculation:
;				[address]	6
;                             [BP+DI], [BX+SI]  7
;                             [BP+SI], [BX+DI]  8
;              -----------------------------------
;              default segment   SS      DS    +2 for segment override
;                                              +4 for unaligned 16bit access

		dataseg

bit_table	db	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
		db	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2
		db	4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4
		db	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8
		db	16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16
		db	32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
		db	64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64,64
		db	128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128,128


		end

