
; i386 implementation

	bits 32
	
	global fast_sieve

	section	.text
	align 32
	
fast_sieve: 

	sub	esp, 28
	push	ebp
	push	edi
	push	esi
	push	ebx		; esp=orig_esp-28-4*4=orig_esp-44


	mov	ebx, [52+esp]	; n = [orig_esp+8]
	mov	ecx, ebx
	shr	ecx, 1
	lea	edx, [ebx*8]	; N = 8*n
	mov	[28+esp], edx	; [orig_esp-16] = N
	mov 	edi, [48+esp]	; edi = a
	mov	esi, edi
	add	esi, ebx	; esi = b = a+n

	mov	ebp, edi	; ebp = a
	mov	eax, 0x5555
	cld
	rep	stosw	
	test	ebx, 1
	jz	even
	stosb
even:
	mov	BYTE [ebp], 0x53	; a[0]=0x53
	mov	edi, ebp	; edi = a
	mov	ebp, esi	; ebp = b

	mov	esi, 2		; esi = k = 2
	lea	eax, [2*esi]
	mov	DWORD [16+esp], eax  ; kk=4

continue:
	lea	ecx, [1+2*esi]		; ecx=1+2*k
	inc	esi			; k++
	mov	eax, DWORD [16+esp]	; kk+=ecx
	add	eax, ecx
	cmp	eax, DWORD [28+esp]
	jae	quit
	mov	DWORD [16+esp], eax

	mov	edx, esi
	mov	eax, 1
	mov	ecx, esi
	sar	edx, 3			; edx=k>>3
	and	ecx, 7			; al=1<<(k&7)
	sal	eax, cl
	test	BYTE [edi+edx], al
	jnz	continue
	
	lea	ebx, [2*esi]
	sub	ebx, DWORD [28+esp]	; ebx=i=2*k-N
	jns	continue
	align 32
inner_loop:		
    ; INPUT ebx=i esi=k ebp=b
    ; USING eax=1<<(i&7) ebx=i ecx=i&7 edx=i>>3 esi=k ebp=b 
    ; FREE  edi
%rep 1				;0 for original x86asm-version, 1 for u86asm
	mov	edx, ebx	;it was found that 1 is optimal for Athlon-XP CPU
	mov	eax, 1
	mov	ecx, ebx
	sar	edx, 3			; edx=i>>3
	and	ecx, 7
	sal	eax, cl
	or	BYTE [ebp+edx], al
	add	ebx, esi		; ebx=i, esi=k
	jns	continue
%endrep
	mov	edx, ebx
	mov	eax, 1
	mov	ecx, ebx
	sar	edx, 3			; edx=i>>3
	and	ecx, 7
	sal	eax, cl
	or	BYTE [ebp+edx], al
	add	ebx, esi		; ebx=i, esi=k
	js	inner_loop
	jmp 	continue

quit:
	pop	ebx
	pop	esi
	pop	edi
	pop	ebp
	add	esp, 28
	ret


